import os
import os.path

import PTVhtml

class PTVWebKit(PTVhtml.PTVhtml):
	def __init__(self, view, home, share_path):
		PTVhtml.PTVhtml.__init__(self, view, home, share_path)
		self._view = view
		self._home = home
		self._css = ""
		self._wkview = None
		self._stream_url = None

		f = open(os.path.join(share_path, "gtkhtml.css"))
		for l in f.readlines(): self._css += l
		f.close()

	def finish(self):
		pass

	def is_ajax_ok(self):
		return True

	def post_show_init(self, widget):
		import webkit
		self._wkview = webkit.WebView()
		widget.add_with_viewport(self._wkview)

		self._wkview.connect("navigation-policy-decision-requested", self._open_uri_cb)
		self._wkview.connect("new-window-policy-decision-requested", self._new_window_cb)
		self._wkview.connect("hovering-over-link", self._link_hover_cb)

	def build_header(self, html):
		header = ["""<html><head>
			    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<style type="text/css">
%s
</style>
			    <title>title</title>""" % self._css] 
		header.append(html)
		header.append("""</head>""")
		return "\n".join(header)

	def render(self, html, stream_url="file:///", image_id=None):
		self._stream_url = stream_url
		self._wkview.load_string(html, 'text/html', 'UTF-8', stream_url)

	def dl_interrupt(self):
		pass

	def _open_uri_cb(self, view, frame, request, navigation_action, policy_decision):
		uri = request.get_uri()
		print "PTVWebKit._open_uri_cb - " + uri
		if uri == self._stream_url:
			policy_decision.use()
			return True
		policy_decision.ignore()
		self.emit('open-uri', uri)
		return True

	def _new_window_cb(self, view, frame, request, navigation_action, policy_decision):
		policy_decision.ignore()
		return True

	def _link_hover_cb(self, view, title, uri):
		self.emit('link-message', title)
